[build-system]
requires = ["pbr>=5.7.0", "setuptools>=36.6.0", "wheel"]
build-backend = "pbr.build"

[tool.ruff]
line-length = 120
target-version = 'py311'
include = ["docs/*.py", "omniconf/**/*.py", "setup.py"]

[tool.ruff.lint]
select = [
  "E4",  # ruff defaults
  "E7",
  "E9",
  "F",   # pyflakes
  "W",   # pycodestyle
  "ERA", # eradicate
  "YTT", # flake8-2020
  "BLE", # flake8-blind-except
  "B",   # flake8-bugbear
  "C4",  # flake8-comprehensions
  "CPY", # flake8-copyright
  "FA",  # flake8-future-annotations
  "SIM", # flake8-simplify
  "TD",  # flake8-todos
  "RUF", # ruff
  "I",   # imports
]

[tool.mypy]
python_version = "3.11"
strict = true
scripts_are_modules = true
warn_return_any = true
warn_unused_configs = true
plugins = [
  "omniconf.mypy.plugin"
]

[[tool.mypy.overrides]]
module = [
  "configobj",             # public library, missing typing
]
ignore_missing_imports = true
